<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\orders;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\orders\RechargeOrder;
use app\common\lists\ListsSearchInterface;
use think\db\Query;


/**
 * RechargeOrder列表
 * Class RechargeOrderLists
 * @package app\adminapi\listsorders
 */
class RechargeOrderLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public function setSearch(): array
    {
        return [
            '=' => ['sn', 'work_id', 'user_id', 'payment_type', 'pay_sn', 'pay_way', 'pay_status', 'pay_time', 'order_terminal', 'transaction_id', 'refund_status', 'refund_transaction_id'],

        ];
    }


    public function queryWhere():array
    {
        $where = [];
        if(isset($this->params['create_time']) && !empty($this->params['create_time'])){
            $time = [strtotime($this->params['create_time'][0]), strtotime($this->params['create_time'][1])];
            $where[] = ['create_time', 'between', $time];
        }
        if(isset($this->params['update_time']) && !empty($this->params['update_time'])){
            $time = [strtotime($this->params['update_time'][0]), strtotime($this->params['update_time'][1])];
            $where[] = ['update_time', 'between', $time];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public function lists(): array
    {
        return RechargeOrder::with(['orderGoods'=>function(Query $query){
            $query->field('id,sn,goods_id,goods_name,goods_image,goods_number,good_unit,goods_size,goods_type,goods_brand,base_service_fee,service_total,service_fee')->order(['id'=>'desc']);
        }])->where($this->searchWhere)
            ->where($this->queryWhere())
            ->field(['id', 'sn', 'work_id', 'user_id', 'payment_type', 'pay_sn', 'pay_way', 'pay_status', 'pay_time', 'order_total', 'order_amount', 'order_terminal', 'transaction_id', 'refund_status', 'refund_transaction_id', 'create_time', 'update_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public function count(): int
    {
        return RechargeOrder::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}